;    guilayout_demo5.pb
;    Version 0.2 [2012/05/20]
;    Copyright (C) 2012 Ronny Krueger
;
;    This file is part of AWPB-Tools.
;
;    AWPB-Tools is free software: you can redistribute it and/or modify
;    it under the terms of the GNU Lesser General Public License as published by
;    the Free Software Foundation, either version 3 of the License, or
;    (at your option) any later version.
;
;    AWPB-Tools is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU Lesser General Public License for more details.
;
;    You should have received a copy of the GNU Lesser General Public License
;    along with AWPB-Tools.  If not, see <http://www.gnu.org/licenses/>.

EnableExplicit

CompilerSelect #PB_Compiler_OS 
  CompilerCase #PB_OS_Windows
    IncludePath "..\include\awpbtools"
  CompilerCase #PB_OS_Linux
    IncludePath "../include/awpbtools"
CompilerEndSelect

XIncludeFile "awguilayout.pbi"

Enumeration
  #option_1
  #option_2
  #option_3
EndEnumeration

Define win, gdg0, gdg1, gdg2, gdg3, gdg4, gdg5
Define *sizer.AWPB_GUILO_Sizer, s1.i, s2.i, s3.i
Define fs0.i, fs1.i, fs2.i, fs3.i, fs4.i, fs5.i

; If LoadFont(1, "Arial", 5)
;   SetGadgetFont(#PB_Default, FontID(1))
; EndIf
    
win = OpenWindow(#PB_Any, 542, 122, 410, 410, "GUI-Layout-Demo", #PB_Window_SystemMenu|#PB_Window_SizeGadget|#PB_Window_MinimizeGadget|#PB_Window_TitleBar)
If IsWindow(win)
  *sizer = AWPB_CreateSizerObj(win)
  If *sizer
    gdg0 = Frame3DGadget(#PB_Any, 0, 0, 1, 1, "Frame 0 20% height, 100% width")
    OptionGadget(#option_1, 0, 0, 1, 1, "Option 1")
    OptionGadget(#option_2, 0, 0, 1, 1, "Option 2")
    OptionGadget(#option_3, 0, 0, 1, 1, "Option 3")
    SetGadgetState(#option_2, 1) 
        
    gdg1 = Frame3DGadget(#PB_Any, 0, 0, 1, 1, "Frame 1 - with borders a 10 px, 20% height, 100% width", #PB_Frame3D_Double)
    gdg2 = Frame3DGadget(#PB_Any, 0, 0, 1, 1, "Frame 2 - 60% height, 50% width")
    gdg3 = Frame3DGadget(#PB_Any, 0, 0, 1, 1, "Frame 3 - 30% height, 25% width", #PB_Frame3D_Double)
    gdg4 = Frame3DGadget(#PB_Any, 0, 0, 1, 1, "Frame 4 - with borders a 5 px, 30% height, 25% width")
    gdg5 = Frame3DGadget(#PB_Any, 0, 0, 1, 1, "Frame 5 - 60% height, 25% width")
    
    ; only needed for linux, since title does not resize correctly
    CompilerIf #PB_Compiler_OS = #PB_OS_Linux
    	AWPB_GUILO_Fix_Frame3DGadget_Resize(gdg0)
    	AWPB_GUILO_Fix_Frame3DGadget_Resize(gdg1)
    	AWPB_GUILO_Fix_Frame3DGadget_Resize(gdg2)
    	AWPB_GUILO_Fix_Frame3DGadget_Resize(gdg3)
    	AWPB_GUILO_Fix_Frame3DGadget_Resize(gdg4)
    	AWPB_GUILO_Fix_Frame3DGadget_Resize(gdg5)
    CompilerEndIf
    
    s1  = *sizer\AddSizer(#Null, #AWPB_GUILO_SIZER_VBOX, 100)
    fs0 = *sizer\AddFramedSizer(s1, gdg0, #AWPB_GUILO_SIZER_HBOX, 20)
   				*sizer\AddGadget(fs0, #option_1, 30)
   				*sizer\AddGadget(fs0, #option_2, 30)
   				*sizer\AddGadget(fs0, #option_3, 30)
    fs1 = *sizer\AddFramedSizer(s1, gdg1, #AWPB_GUILO_SIZER_VBOX, 20)
    s2  = *sizer\AddSizer(s1, #AWPB_GUILO_SIZER_HBOX, 60)
    fs2 = *sizer\AddFramedSizer(s2, gdg2, #AWPB_GUILO_SIZER_VBOX, 50)
    s3  = *sizer\AddSizer(s2, #AWPB_GUILO_SIZER_VBOX, 25)
    fs3 = *sizer\AddFramedSizer(s3, gdg3, #AWPB_GUILO_SIZER_VBOX, 50)
    fs4 = *sizer\AddFramedSizer(s3, gdg4, #AWPB_GUILO_SIZER_VBOX, 50)
    fs5 = *sizer\AddFramedSizer(s2, gdg5, #AWPB_GUILO_SIZER_VBOX, 25)
    
    *sizer\Finish()
      
    Repeat
      Select WaitWindowEvent()
        Case #PB_Event_SizeWindow
          *sizer\Resize()
        Case #PB_Event_CloseWindow
          Select EventWindow()
            Case win
              CloseWindow(win)
              win = 0
              Break
          EndSelect
      EndSelect
    ForEver
    
    *sizer\Destroy()
  Else
    MessageRequester("Fehler", "Konnte Sizer nicht erstellen") 
  EndIf
Else
  MessageRequester("Fehler", "Konnte Fenster nicht erstellen") 
EndIf

End


