;	 maildec_demo.pb
;	 Version 0.2 [2010/10/09]
;    Copyright (C) 2011 Ronny Krueger
;
;    This file is part of AWPB-Tools.
;
;    AWPB-Tools is free software: you can redistribute it and/or modify
;    it under the terms of the GNU Lesser General Public License as published by
;    the Free Software Foundation, either version 3 of the License, or
;    (at your option) any later version.
;
;    AWPB-Tools is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU Lesser General Public License for more details.
;
;    You should have received a copy of the GNU Lesser General Public License
;    along with AWPB-Tools.  If not, see <http://www.gnu.org/licenses/>.

EnableExplicit

CompilerSelect #PB_Compiler_OS 
  CompilerCase #PB_OS_Windows
    IncludePath "..\include\awpbtools"
  CompilerCase #PB_OS_Linux
    IncludePath "../include/awpbtools"
CompilerEndSelect

XIncludeFile "awmessage.pbi"

OpenConsole()

PrintN("AWPB-Tools MailEncoder-Demo")
PrintN("")

Define *msg.AWPB_Message, file.s, loaded.b, *attlist.AWPB_MSG_AttList, *attit.AWPB_MSG_AttList, folder.s

Print("Allocating Message ... ")
*msg = AWPB_CreateMessageObj()
If *msg
  PrintN("success")
  file = OpenFileRequester("Mail auswhlen", "", "EML-Files (*.EML)|*.EML|Binary MailFiles (*.BIN)|*.BIN", 0)
  If file
    Print("Loading mail ... ")
    If LCase(GetExtensionPart(file)) = "eml"
      loaded = *msg\LoadEML(file)
    Else ; *bin
      loaded = *msg\Load(file)
    EndIf
    If loaded
      PrintN("success")
      Print("Decoding mail ... ")
      If *msg\Decode()
        PrintN("success")
        PrintN("From:            >" + *msg\GetHeaderField(#AWPB_HDR_FROM) + "<")
        PrintN("To:              >" + *msg\GetHeaderField(#AWPB_HDR_TO) + "<")
        PrintN("To (adr only):   >" + *msg\GetHeaderField(#AWPB_HDR_TO_MAILS) + "<")
        PrintN("CC:              >" + *msg\GetHeaderField(#AWPB_HDR_CC) + "<")
        PrintN("CC (adr only):   >" + *msg\GetHeaderField(#AWPB_HDR_CC_MAILS) + "<")
        PrintN("Date:            >" + FormatDate("%dd.%mm.%yyyy %hh:%ii:%ss", *msg\GetDate()) + "<")    
        PrintN("Date RFC:        >" + *msg\GetHeaderField(#AWPB_HDR_DATE) + "<")   
        PrintN("Subject:         >" + *msg\GetHeaderField(#AWPB_HDR_SUBJECT) + "<")
        PrintN("Lnge HTML Body: >" + Str(Len(*msg\GetHTML())) + "<")
        PrintN("Lnge Text Body: >" + Str(Len(*msg\GetPlain())) + "<")
        Print("Building Attachment-List ... ")
        *attlist = *msg\BuildAttachmentList()
        If *attlist
          PrintN("success")
          *attit = *attlist
          While *attit
            PrintN("Found Attachment Name: " + *msg\GetHeaderField(#AWPB_HDR_CONTENTNAME, *attit\Att) + " / Filename: " + *msg\GetHeaderField(#AWPB_HDR_CONTENTFILENAME, *attit\Att))
            *attit = *attit\Next
          Wend
          
          folder = PathRequester("Save Attachments to", GetCurrentDirectory())
          If folder
            Print("Saving ... ")
            *attit = *attlist
            While *attit
              If *msg\SavePartToFile(*attit\Att, folder + *msg\GetHeaderField(#AWPB_HDR_CONTENTFILENAME, *attit\Att))
                Print("+")
              Else
                Print("-")
              EndIf
              *attit = *attit\Next
            Wend
            PrintN(" ... done")
          EndIf
          *msg\FreeAttachmentList(*attlist)
        Else
          PrintN("failed")
        EndIf
      Else
        PrintN("failed")
      EndIf
    Else
      PrintN("failed")
    EndIf
  EndIf
  *msg\Destroy()
EndIf
  
PrintN("Press return to exit")
Input()

