EnableExplicit

CompilerSelect #PB_Compiler_OS 
  CompilerCase #PB_OS_Windows
    IncludePath "..\include\awpbtools"
  CompilerCase #PB_OS_Linux
    IncludePath "../include/awpbtools"
CompilerEndSelect

XIncludeFile "awmessage.pbi"

; First you intanciate an AWPB-Message Object

Define *message.AWPB_Message

*message = AWPB_CreateMessageObj()
If *message = #Null : End : EndIf

; Load a plain email from disk (you can use the generated from message_demo1 or some other eml-file (maybe an exported thunderbird mail)

*message\LoadEML("plainmail.eml") ; LoadEML returns #False if it fails, be sure to check this in a real program

; now call Decode

*message\Decode()	; Decode returns #False if it fails, be sure to check this in a real program

; thats it, the message is decoded and ready to view
; how to access the data:

Debug("From:                 >" + *message\GetHeaderField(#AWPB_HDR_FROM) + "<")
Debug("To:                   >" + *message\GetHeaderField(#AWPB_HDR_TO) + "<")
Debug("To (adr only):        >" + *message\GetHeaderField(#AWPB_HDR_TO_MAILS) + "<")
Debug("CC:                   >" + *message\GetHeaderField(#AWPB_HDR_CC) + "<")
Debug("CC (adr only):        >" + *message\GetHeaderField(#AWPB_HDR_CC_MAILS) + "<")
Debug("Date:                 >" + FormatDate("%dd.%mm.%yyyy %hh:%ii:%ss", *message\GetDate()) + "<")    
Debug("Date RFC:             >" + *message\GetHeaderField(#AWPB_HDR_DATE) + "<")   
Debug("Subject:              >" + *message\GetHeaderField(#AWPB_HDR_SUBJECT) + "<")
Debug("size plain text body: >" + Str(Len(*message\GetPlain())) + "<")
Debug("size full message:    >" + Str(*message\GetSize()) + "<")
Debug("Body Text (max 256B): >" + Left(*message\Getplain(), 256) + "<")

; finally destroy the message-Object to free used resources
*message\Destroy()

End
