;    sqlitedb_demo3.pb
;    Version 0.1 [2012/04/27]
;    Copyright (C) 2012 Ronny Krueger
;
;    This file is part of AWPB-Tools.
;
;    AWPB-Tools is free software: you can redistribute it and/or modify
;    it under the terms of the GNU Lesser General Public License as published by
;    the Free Software Foundation, either version 3 of the License, or
;    (at your option) any later version.
;
;    AWPB-Tools is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU Lesser General Public License for more details.
;
;    You should have received a copy of the GNU Lesser General Public License
;    along with AWPB-Tools.  If not, see <http://www.gnu.org/licenses/>.

EnableExplicit

UseSQLiteDatabase()

CompilerSelect #PB_Compiler_OS 
  CompilerCase #PB_OS_Windows
    IncludePath "..\include\awpbtools"
  CompilerCase #PB_OS_Linux
    IncludePath "../include/awpbtools"
CompilerEndSelect

XIncludeFile "awsqlitedb.pbi"

Define *db.AWPB_SQLiteDB, a.i

OpenConsole()
PrintN("AWPB_SQLiteDB Demo 3")
PrintN("SQLite-Lib Version: " + AWPB_SQLiteLibVersion())
PrintN("")
Print("Creating SQLiteDB Object ... ")
*db = AWPB_CreateSQLiteDBObj()
If *db
	PrintN("success")
	Print("Opening database file ... ")
	If *db\OpenDB("test3.db", "", "")
		PrintN("success")
		Print("Testing if table 'tabelle1' exists ... ")
		If Not *db\TableExists("tabelle1")
			PrintN("not found")
			Print("Creating table 'tabelle1' ... ")
			If *db\Update("CREATE TABLE tabelle1 (name TEXT, age INT)")
				PrintN("success")
			Else
				PrintN("failed")
				*db\CloseDB()
				*db\Destroy()
				PrintN("Press Enter to exit")
				Input()
				CloseConsole()
				End
			EndIf			
		Else
			PrintN("found");
		EndIf
		Print("Insert some data into table ... ")
		
		If *db\BeginTransaction()
			*db\Update("INSERT INTO tabelle1 VALUES ('Meier', 28)")
			*db\Update("INSERT INTO tabelle1 VALUES ('Mller', 29)")
			*db\Update("INSERT INTO tabelle1 VALUES ('Schneider', 18)")
			*db\Update("INSERT INTO tabelle1 VALUES ('Lehmann', 58)")
			If *db\EndTransaction()
				PrintN("done")
			Else
				PrintN("failed")
			EndIf
		Else
			PrintN("done")
		EndIf
		
		Print("Insert some data into table with rollback ... ")
		; diese beiden Namen tauchen in der Tabelle NICHT auf
		If *db\BeginTransaction()
			*db\Update("INSERT INTO tabelle1 VALUES ('Krger', 32)")
			*db\Update("INSERT INTO tabelle1 VALUES ('Schmidt', 44)")
			If *db\CancelTransaction()
				PrintN("done")
			Else
				PrintN("failed")
			EndIf
		Else
			PrintN("done")
		EndIf
		
		Print("Insert again some data into table ... ")
		If *db\BeginTransaction()
			*db\Update("INSERT INTO tabelle1 VALUES ('Richter', 24)")
			*db\Update("INSERT INTO tabelle1 VALUES ('Schuster', 34)")
			If *db\EndTransaction()
				PrintN("done")
			Else
				PrintN("failed")
			EndIf
		Else
			PrintN("done")
		EndIf
		
		Print("Show Table content ... ")
		If *db\Query("SELECT * FROM tabelle1")
			If *db\FirstRow()
				PrintN("ok")
				For a = 1 To *db\Columns()
					PrintN("Column " + Str(a) + " Name: " + *db\ColumnName(a-1))
				Next a
				PrintN("Content:")
				a = 1
				Repeat
					PrintN("(" + Str(a) + ") Name: " + *db\GetString(0) + " - Age: " + Str(*db\GetLong(1)))
					a + 1
				Until Not *db\NextRow()
			EndIf	
		Else
			PrintN("failed")
		EndIf
		*db\CloseDB()
	Else
		PrintN("Failed")
	EndIf
	*db\Destroy()
Else
	PrintN("Failed")
EndIf

PrintN("Press Enter to exit")
Input()
CloseConsole()
End
