;    awcharset.pbi
;    Version 0.2 [2012/05/09]
;    Copyright (C) 2012 Ronny Krger
;
;    This file is part of AWPB-Tools.
;
;    AWPB-Tools is free software: you can redistribute it and/or modify
;    it under the terms of the GNU Lesser General Public License as published by
;    the Free Software Foundation, either version 3 of the License, or
;    (at your option) any later version.
;
;    AWPB-Tools is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU Lesser General Public License for more details.
;
;    You should have received a copy of the GNU Lesser General Public License
;    along with AWPB-Tools.  If not, see <http://www.gnu.org/licenses/>.
;
; Code based on and inspired by:
;
; {==============================================================================|
; | Project : Ararat Synapse                                       | 005.002.002 |
; |==============================================================================|
; | Content: Charset conversion support                                          |
; |==============================================================================|
; | Copyright (c)1999-2004, Lukas Gebauer                                        |
; | All rights reserved.                                                         |
; |                                                                              |
; | Redistribution And use in source And binary forms, With Or without           |
; | modification, are permitted provided that the following conditions are met:  |
; |                                                                              |
; | Redistributions of source code must retain the above copyright notice, this  |
; | List of conditions And the following disclaimer.                             |
; |                                                                              |
; | Redistributions in binary form must reproduce the above copyright notice,    |
; | this List of conditions And the following disclaimer in the documentation    |
; | And/Or other materials provided With the distribution.                       |
; |                                                                              |
; | Neither the name of Lukas Gebauer nor the names of its contributors may      |
; | be used To endorse Or promote products derived from this software without    |
; | specific prior written permission.                                           |
; |                                                                              |
; | THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS And CONTRIBUTORS "AS IS"  |
; | And ANY EXPRESS Or IMPLIED WARRANTIES, INCLUDING, BUT Not LIMITED To, THE    |
; | IMPLIED WARRANTIES OF MERCHANTABILITY And FITNESS For A PARTICULAR PURPOSE   |
; | ARE DISCLAIMED. IN NO EVENT SHALL THE REGENTS Or CONTRIBUTORS BE LIABLE For  |
; | ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, Or CONSEQUENTIAL       |
; | DAMAGES (INCLUDING, BUT Not LIMITED To, PROCUREMENT OF SUBSTITUTE GOODS Or   |
; | SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER   |
; | CAUSED And ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT           |
; | LIABILITY, Or TORT (INCLUDING NEGLIGENCE Or OTHERWISE) ARISING IN ANY WAY    |
; | OUT OF THE USE OF THIS SOFTWARE, EVEN If ADVISED OF THE POSSIBILITY OF SUCH  |
; | DAMAGE.                                                                      |
; |==============================================================================|
; | The Initial Developer of the Original Code is Lukas Gebauer (Czech Republic).|
; | Portions created by Lukas Gebauer are Copyright (c)2000-2004.                |
; | All Rights Reserved.                                                         |
; |==============================================================================|
; | Contributor(s):                                                              |
; |==============================================================================|
; | History: see HISTORY.HTM from distribution package                           |
; |          (Found at URL: http://www.ararat.cz/synapse/)                       |
; |==============================================================================}

XIncludeFile "awsupport.pbi"

;{ Constants
Enumeration
	#AWPB_CS_CS_UNKNOWN                 ;* unbekanntes Charset, nur zur Ergebnisauswertung
	#AWPB_CS_CS_ISO_8859_1
	#AWPB_CS_CS_ISO_8859_2
	#AWPB_CS_CS_ISO_8859_3
	#AWPB_CS_CS_ISO_8859_4
	#AWPB_CS_CS_ISO_8859_5
	#AWPB_CS_CS_ISO_8859_6
	#AWPB_CS_CS_ISO_8859_7
	#AWPB_CS_CS_ISO_8859_8
	#AWPB_CS_CS_ISO_8859_9
	#AWPB_CS_CS_ISO_8859_10
	#AWPB_CS_CS_ISO_8859_13
	#AWPB_CS_CS_ISO_8859_14 
	#AWPB_CS_CS_ISO_8859_15
	#AWPB_CS_CS_CP1250
	#AWPB_CS_CS_CP1251
	#AWPB_CS_CS_CP1252
	#AWPB_CS_CS_CP1253
	#AWPB_CS_CS_CP1254
	#AWPB_CS_CS_CP1255
  #AWPB_CS_CS_CP1256
	#AWPB_CS_CS_CP1257
	#AWPB_CS_CS_CP1258
	#AWPB_CS_CS_KOI8_R
	#AWPB_CS_CS_CP895
	#AWPB_CS_CS_CP852
	#AWPB_CS_CS_UCS_2
	#AWPB_CS_CS_UCS_4
	#AWPB_CS_CS_UTF_8
	#AWPB_CS_CS_UTF_7
  #AWPB_CS_CS_UTF_7mod
	#AWPB_CS_CS_UCS_2LE
	#AWPB_CS_CS_UCS_4LE
  ; next are supported by Iconv only...
  #AWPB_CS_CS_UTF_16
	#AWPB_CS_CS_UTF_16LE
	#AWPB_CS_CS_UTF_32
	#AWPB_CS_CS_UTF_32LE
	#AWPB_CS_CS_C99
	#AWPB_CS_CS_JAVA
	#AWPB_CS_CS_ISO_8859_16
	#AWPB_CS_CS_KOI8_U
	#AWPB_CS_CS_KOI8_RU
  #AWPB_CS_CS_CP862
	#AWPB_CS_CS_CP866
	#AWPB_CS_CS_MAC
	#AWPB_CS_CS_MACCE
	#AWPB_CS_CS_MACICE
	#AWPB_CS_CS_MACCRO
	#AWPB_CS_CS_MACRO
	#AWPB_CS_CS_MACCYR
	#AWPB_CS_CS_MACUK
	#AWPB_CS_CS_MACGR
	#AWPB_CS_CS_MACTU
  #AWPB_CS_CS_MACHEB
	#AWPB_CS_CS_MACAR
	#AWPB_CS_CS_MACTH
	#AWPB_CS_CS_ROMAN8
	#AWPB_CS_CS_NEXTSTEP
	#AWPB_CS_CS_ARMASCII
	#AWPB_CS_CS_GEORGIAN_AC
	#AWPB_CS_CS_GEORGIAN_PS
  #AWPB_CS_CS_KOI8_T
	#AWPB_CS_CS_MULELAO
	#AWPB_CS_CS_CP1133
	#AWPB_CS_CS_TIS620
	#AWPB_CS_CS_CP874
	#AWPB_CS_CS_VISCII
	#AWPB_CS_CS_TCVN
	#AWPB_CS_CS_ISO_IR_14
	#AWPB_CS_CS_JIS_X0201
  #AWPB_CS_CS_JIS_X0208
	#AWPB_CS_CS_JIS_X0212
	#AWPB_CS_CS_GB1988_80
	#AWPB_CS_CS_GB2312_80
	#AWPB_CS_CS_ISO_IR_165
	#AWPB_CS_CS_ISO_IR_149
	#AWPB_CS_CS_EUC_JP
  #AWPB_CS_CS_SHIFT_JIS
	#AWPB_CS_CS_CP932
	#AWPB_CS_CS_ISO_2022_JP
	#AWPB_CS_CS_ISO_2022_JP1
	#AWPB_CS_CS_ISO_2022_JP2
	#AWPB_CS_CS_GB2312
	#AWPB_CS_CS_CP936
  #AWPB_CS_CS_GB18030
	#AWPB_CS_CS_ISO_2022_CN
	#AWPB_CS_CS_ISO_2022_CNE
	#AWPB_CS_CS_HZ
	#AWPB_CS_CS_EUC_TW
	#AWPB_CS_CS_BIG5
	#AWPB_CS_CS_CP950
	#AWPB_CS_CS_BIG5_HKSCS
  #AWPB_CS_CS_EUC_KR
	#AWPB_CS_CS_CP949
	#AWPB_CS_CS_CP1361
	#AWPB_CS_CS_ISO_2022_KR
	#AWPB_CS_CS_CP737
	#AWPB_CS_CS_CP775
	#AWPB_CS_CS_CP853
	#AWPB_CS_CS_CP855
	#AWPB_CS_CS_CP857
  #AWPB_CS_CS_CP858
	#AWPB_CS_CS_CP860
	#AWPB_CS_CS_CP861
	#AWPB_CS_CS_CP863
	#AWPB_CS_CS_CP864
	#AWPB_CS_CS_CP865
	#AWPB_CS_CS_CP869
	#AWPB_CS_CS_CP1125
EndEnumeration
;}
;{ private functions
Procedure.i ____CS_GetCharsetCode(charset.s)
  Protected c.s, t.i
  
  c = UCase(charset)
	If c = "ISO-8859-1"
		t = #AWPB_CS_CS_ISO_8859_1
	ElseIf c = "CP819"
		t = #AWPB_CS_CS_ISO_8859_1
	ElseIf c = "IBM819"
		t = #AWPB_CS_CS_ISO_8859_1
	ElseIf c = "ISO-IR-100"
		t = #AWPB_CS_CS_ISO_8859_1
	ElseIf c = "ISO8859-1"
		t = #AWPB_CS_CS_ISO_8859_1
	ElseIf c = "ISO_8859-1"
		t = #AWPB_CS_CS_ISO_8859_1
	ElseIf c = "ISO_8859-1:1987"
		t = #AWPB_CS_CS_ISO_8859_1
	ElseIf c = "L1"
		t = #AWPB_CS_CS_ISO_8859_1
	ElseIf c = "LATIN1"
		t = #AWPB_CS_CS_ISO_8859_1
	ElseIf c = "CSISOLATIN1"
		t = #AWPB_CS_CS_ISO_8859_1
	ElseIf c = "UTF-8"
		t = #AWPB_CS_CS_UTF_8
	ElseIf c = "ISO-10646-UCS-2"
		t = #AWPB_CS_CS_UCS_2
	ElseIf c = "UCS-2"
		t = #AWPB_CS_CS_UCS_2
	ElseIf c = "CSUNICODE"
		t = #AWPB_CS_CS_UCS_2
	ElseIf c = "UCS-2BE"
		t = #AWPB_CS_CS_UCS_2
	ElseIf c = "UNICODE-1-1"
		t = #AWPB_CS_CS_UCS_2
	ElseIf c = "UNICODEBIG"
		t = #AWPB_CS_CS_UCS_2
	ElseIf c = "CSUNICODE11"
		t = #AWPB_CS_CS_UCS_2
	ElseIf c = "UCS-2LE"
		t = #AWPB_CS_CS_UCS_2LE
	ElseIf c = "UNICODELITTLE"
		t = #AWPB_CS_CS_UCS_2LE
	ElseIf c = "ISO-10646-UCS-4"
		t = #AWPB_CS_CS_UCS_4
	ElseIf c = "UCS-4"
		t = #AWPB_CS_CS_UCS_4
	ElseIf c = "CSUCS4"
		t = #AWPB_CS_CS_UCS_4
	ElseIf c = "UCS-4BE"
		t = #AWPB_CS_CS_UCS_4
	ElseIf c = "UCS-4LE"
		t = #AWPB_CS_CS_UCS_2LE
	ElseIf c = "UTF-16"
		t = #AWPB_CS_CS_UTF_16
	ElseIf c = "UTF-16BE"
		t = #AWPB_CS_CS_UTF_16
	ElseIf c = "UTF-16LE"
		t = #AWPB_CS_CS_UTF_16LE
	ElseIf c = "UTF-32"
		t = #AWPB_CS_CS_UTF_32
	ElseIf c = "UTF-32BE"
		t = #AWPB_CS_CS_UTF_32
	ElseIf c = "UTF-32LE"
		t = #AWPB_CS_CS_UTF_32
	ElseIf c = "UNICODE-1-1-UTF-7"
		t = #AWPB_CS_CS_UTF_7
	ElseIf c = "UTF-7"
		t = #AWPB_CS_CS_UTF_7
	ElseIf c = "CSUNICODE11UTF7"
		t = #AWPB_CS_CS_UTF_7
	ElseIf c = "C99"
		t = #AWPB_CS_CS_C99
	ElseIf c = "JAVA"
		t = #AWPB_CS_CS_JAVA
	ElseIf c = "US-ASCII"
		t = #AWPB_CS_CS_ISO_8859_1
	ElseIf c = "ANSI_X3.4-1968"
		t = #AWPB_CS_CS_ISO_8859_1
	ElseIf c = "ANSI_X3.4-1986"
		t = #AWPB_CS_CS_ISO_8859_1
	ElseIf c = "ASCII"
		t = #AWPB_CS_CS_ISO_8859_1
	ElseIf c = "CP367"
		t = #AWPB_CS_CS_ISO_8859_1
	ElseIf c = "IBM367"
		t = #AWPB_CS_CS_ISO_8859_1
	ElseIf c = "ISO-IR-6"
		t = #AWPB_CS_CS_ISO_8859_1
	ElseIf c = "ISO646-US"
		t = #AWPB_CS_CS_ISO_8859_1
	ElseIf c = "ISO_646.IRV:1991"
		t = #AWPB_CS_CS_ISO_8859_1
	ElseIf c = "US"
		t = #AWPB_CS_CS_ISO_8859_1
	ElseIf c = "CSASCII"
		t = #AWPB_CS_CS_ISO_8859_1
	ElseIf c = "ISO-8859-2"
		t = #AWPB_CS_CS_ISO_8859_2
	ElseIf c = "ISO-IR-101"
		t = #AWPB_CS_CS_ISO_8859_2
	ElseIf c = "ISO8859-2"
		t = #AWPB_CS_CS_ISO_8859_2
	ElseIf c = "ISO_8859-2"
		t = #AWPB_CS_CS_ISO_8859_2
	ElseIf c = "ISO_8859-2:1987"
		t = #AWPB_CS_CS_ISO_8859_2
	ElseIf c = "L2"
		t = #AWPB_CS_CS_ISO_8859_2
	ElseIf c = "LATIN2"
		t = #AWPB_CS_CS_ISO_8859_2
	ElseIf c = "CSISOLATIN2"
		t = #AWPB_CS_CS_ISO_8859_2
	ElseIf c = "ISO-8859-3"
		t = #AWPB_CS_CS_ISO_8859_3
	ElseIf c = "ISO-IR-109"
		t = #AWPB_CS_CS_ISO_8859_3
	ElseIf c = "ISO8859-3"
		t = #AWPB_CS_CS_ISO_8859_3
	ElseIf c = "ISO_8859-3"
		t = #AWPB_CS_CS_ISO_8859_3
	ElseIf c = "ISO_8859-3:1988"
		t = #AWPB_CS_CS_ISO_8859_3
	ElseIf c = "L3"
		t = #AWPB_CS_CS_ISO_8859_3
	ElseIf c = "LATIN3"
		t = #AWPB_CS_CS_ISO_8859_3
	ElseIf c = "CSISOLATIN3"
		t = #AWPB_CS_CS_ISO_8859_3
	ElseIf c = "ISO-8859-4"
		t = #AWPB_CS_CS_ISO_8859_4
	ElseIf c = "ISO-IR-110"
		t = #AWPB_CS_CS_ISO_8859_4
	ElseIf c = "ISO8859-4"
		t = #AWPB_CS_CS_ISO_8859_4
	ElseIf c = "ISO_8859-4"
		t = #AWPB_CS_CS_ISO_8859_4
	ElseIf c = "ISO_8859-4:1988"
		t = #AWPB_CS_CS_ISO_8859_4
	ElseIf c = "L4"
		t = #AWPB_CS_CS_ISO_8859_4
	ElseIf c = "LATIN4"
		t = #AWPB_CS_CS_ISO_8859_4
	ElseIf c = "CSISOLATIN4"
		t = #AWPB_CS_CS_ISO_8859_4
	ElseIf c = "ISO-8859-5"
		t = #AWPB_CS_CS_ISO_8859_5
	ElseIf c = "CYRILLIC"
		t = #AWPB_CS_CS_ISO_8859_5
	ElseIf c = "ISO-IR-144"
		t = #AWPB_CS_CS_ISO_8859_5
	ElseIf c = "ISO8859-5"
		t = #AWPB_CS_CS_ISO_8859_5
	ElseIf c = "ISO_8859-5"
		t = #AWPB_CS_CS_ISO_8859_5
	ElseIf c = "ISO_8859-5:1988"
		t = #AWPB_CS_CS_ISO_8859_5
	ElseIf c = "CSISOLATINCYRILLIC"
		t = #AWPB_CS_CS_ISO_8859_5
	ElseIf c = "ISO-8859-6"
		t = #AWPB_CS_CS_ISO_8859_6
	ElseIf c = "ARABIC"
		t = #AWPB_CS_CS_ISO_8859_6
	ElseIf c = "ASMO-708"
		t = #AWPB_CS_CS_ISO_8859_6
	ElseIf c = "ECMA-114"
		t = #AWPB_CS_CS_ISO_8859_6
	ElseIf c = "ISO-IR-127"
		t = #AWPB_CS_CS_ISO_8859_6
	ElseIf c = "ISO8859-6"
		t = #AWPB_CS_CS_ISO_8859_6
	ElseIf c = "ISO_8859-6"
		t = #AWPB_CS_CS_ISO_8859_6
	ElseIf c = "ISO_8859-6:1987"
		t = #AWPB_CS_CS_ISO_8859_6
	ElseIf c = "CSISOLATINARABIC"
		t = #AWPB_CS_CS_ISO_8859_6
	ElseIf c = "ISO-8859-7"
		t = #AWPB_CS_CS_ISO_8859_7
	ElseIf c = "ECMA-118"
		t = #AWPB_CS_CS_ISO_8859_7
	ElseIf c = "ELOT_928"
		t = #AWPB_CS_CS_ISO_8859_7
	ElseIf c = "GREEK"
		t = #AWPB_CS_CS_ISO_8859_7
	ElseIf c = "GREEK8"
		t = #AWPB_CS_CS_ISO_8859_7
	ElseIf c = "ISO-IR-126"
		t = #AWPB_CS_CS_ISO_8859_7
	ElseIf c = "ISO8859-7"
		t = #AWPB_CS_CS_ISO_8859_7
	ElseIf c = "ISO_8859-7"
		t = #AWPB_CS_CS_ISO_8859_7
	ElseIf c = "ISO_8859-7:1987"
		t = #AWPB_CS_CS_ISO_8859_7
	ElseIf c = "CSISOLATINGREEK"
		t = #AWPB_CS_CS_ISO_8859_7
	ElseIf c = "ISO-8859-8"
		t = #AWPB_CS_CS_ISO_8859_8
	ElseIf c = "HEBREW"
		t = #AWPB_CS_CS_ISO_8859_8
	ElseIf c = "ISO_8859-8"
		t = #AWPB_CS_CS_ISO_8859_8
	ElseIf c = "ISO-IR-138"
		t = #AWPB_CS_CS_ISO_8859_8
	ElseIf c = "ISO8859-8"
		t = #AWPB_CS_CS_ISO_8859_8
	ElseIf c = "ISO_8859-8:1988"
		t = #AWPB_CS_CS_ISO_8859_8
	ElseIf c = "CSISOLATINHEBREW"
		t = #AWPB_CS_CS_ISO_8859_8
	ElseIf c = "ISO-8859-8-I"
		t = #AWPB_CS_CS_ISO_8859_8
	ElseIf c = "ISO-8859-9"
		t = #AWPB_CS_CS_ISO_8859_9
	ElseIf c = "ISO-IR-148"
		t = #AWPB_CS_CS_ISO_8859_9
	ElseIf c = "ISO8859-9"
		t = #AWPB_CS_CS_ISO_8859_9
	ElseIf c = "ISO_8859-9"
		t = #AWPB_CS_CS_ISO_8859_9
	ElseIf c = "ISO_8859-9:1989"
		t = #AWPB_CS_CS_ISO_8859_9
	ElseIf c = "L5"
		t = #AWPB_CS_CS_ISO_8859_9
	ElseIf c = "LATIN5"
		t = #AWPB_CS_CS_ISO_8859_9
	ElseIf c = "CSISOLATIN5"
		t = #AWPB_CS_CS_ISO_8859_9
	ElseIf c = "ISO-8859-10"
		t = #AWPB_CS_CS_ISO_8859_10
	ElseIf c = "ISO-IR-157"
		t = #AWPB_CS_CS_ISO_8859_10
	ElseIf c = "ISO8859-10"
		t = #AWPB_CS_CS_ISO_8859_10
	ElseIf c = "ISO_8859-10"
		t = #AWPB_CS_CS_ISO_8859_10
	ElseIf c = "ISO_8859-10:1992"
		t = #AWPB_CS_CS_ISO_8859_10
	ElseIf c = "L6"
		t = #AWPB_CS_CS_ISO_8859_10
	ElseIf c = "LATIN6"
		t = #AWPB_CS_CS_ISO_8859_10
	ElseIf c = "CSISOLATIN6"
		t = #AWPB_CS_CS_ISO_8859_10
	ElseIf c = "ISO-8859-13"
		t = #AWPB_CS_CS_ISO_8859_13
	ElseIf c = "ISO-IR-179"
		t = #AWPB_CS_CS_ISO_8859_13
	ElseIf c = "ISO8859-13"
		t = #AWPB_CS_CS_ISO_8859_13
	ElseIf c = "ISO_8859-13"
		t = #AWPB_CS_CS_ISO_8859_13
	ElseIf c = "L7"
		t = #AWPB_CS_CS_ISO_8859_13
	ElseIf c = "LATIN7"
		t = #AWPB_CS_CS_ISO_8859_13
	ElseIf c = "ISO-8859-14"
		t = #AWPB_CS_CS_ISO_8859_14
	ElseIf c = "ISO-CELTIC"
		t = #AWPB_CS_CS_ISO_8859_14
	ElseIf c = "ISO-IR-199"
		t = #AWPB_CS_CS_ISO_8859_14
	ElseIf c = "ISO8859-14"
		t = #AWPB_CS_CS_ISO_8859_14
	ElseIf c = "ISO_8859-14"
		t = #AWPB_CS_CS_ISO_8859_14
	ElseIf c = "ISO_8859-14:1998"
		t = #AWPB_CS_CS_ISO_8859_14
	ElseIf c = "L8"
		t = #AWPB_CS_CS_ISO_8859_14
	ElseIf c = "LATIN8"
		t = #AWPB_CS_CS_ISO_8859_14
	ElseIf c = "ISO-8859-15"
		t = #AWPB_CS_CS_ISO_8859_15
	ElseIf c = "ISO-IR-203"
		t = #AWPB_CS_CS_ISO_8859_15
	ElseIf c = "ISO8859-15"
		t = #AWPB_CS_CS_ISO_8859_15
	ElseIf c = "ISO_8859-15"
		t = #AWPB_CS_CS_ISO_8859_15
	ElseIf c = "ISO_8859-15:1998"
		t = #AWPB_CS_CS_ISO_8859_15
	ElseIf c = "ISO-8859-16"
		t = #AWPB_CS_CS_ISO_8859_16
	ElseIf c = "ISO-IR-226"
		t = #AWPB_CS_CS_ISO_8859_16
	ElseIf c = "ISO8859-16"
		t = #AWPB_CS_CS_ISO_8859_16
	ElseIf c = "ISO_8859-16"
		t = #AWPB_CS_CS_ISO_8859_16
	ElseIf c = "ISO_8859-16:2000"
		t = #AWPB_CS_CS_ISO_8859_16
	ElseIf c = "KOI8-R"
		t = #AWPB_CS_CS_KOI8_R
	ElseIf c = "CSKOI8R"
		t = #AWPB_CS_CS_KOI8_R
	ElseIf c = "KOI8-U"
		t = #AWPB_CS_CS_KOI8_U
	ElseIf c = "KOI8-RU"
		t = #AWPB_CS_CS_KOI8_RU
	ElseIf c = "WINDOWS-1250"
		t = #AWPB_CS_CS_CP1250
	ElseIf c = "CP1250"
		t = #AWPB_CS_CS_CP1250
	ElseIf c = "MS-EE"
		t = #AWPB_CS_CS_CP1250
	ElseIf c = "WINDOWS-1251"
		t = #AWPB_CS_CS_CP1251
	ElseIf c = "CP1251"
		t = #AWPB_CS_CS_CP1251
	ElseIf c = "MS-CYRL"
		t = #AWPB_CS_CS_CP1251
	ElseIf c = "WINDOWS-1252"
		t = #AWPB_CS_CS_CP1252
	ElseIf c = "CP1252"
		t = #AWPB_CS_CS_CP1252
	ElseIf c = "MS-ANSI"
		t = #AWPB_CS_CS_CP1252
	ElseIf c = "WINDOWS-1253"
		t = #AWPB_CS_CS_CP1253
	ElseIf c = "CP1253"
		t = #AWPB_CS_CS_CP1253
	ElseIf c = "MS-GREEK"
		t = #AWPB_CS_CS_CP1253
	ElseIf c = "WINDOWS-1254"
		t = #AWPB_CS_CS_CP1254
	ElseIf c = "CP1254"
		t = #AWPB_CS_CS_CP1254
	ElseIf c = "MS-TURK"
		t = #AWPB_CS_CS_CP1254
	ElseIf c = "WINDOWS-1255"
		t = #AWPB_CS_CS_CP1255
	ElseIf c = "CP1255"
		t = #AWPB_CS_CS_CP1255
	ElseIf c = "MS-HEBR"
		t = #AWPB_CS_CS_CP1255
	ElseIf c = "WINDOWS-1256"
		t = #AWPB_CS_CS_CP1256
	ElseIf c = "CP1256"
		t = #AWPB_CS_CS_CP1256
	ElseIf c = "MS-ARAB"
		t = #AWPB_CS_CS_CP1256
	ElseIf c = "WINDOWS-1257"
		t = #AWPB_CS_CS_CP1257
	ElseIf c = "CP1257"
		t = #AWPB_CS_CS_CP1257
	ElseIf c = "WINBALTRIM"
		t = #AWPB_CS_CS_CP1257
	ElseIf c = "WINDOWS-1258"
		t = #AWPB_CS_CS_CP1258
	ElseIf c = "CP1258"
		t = #AWPB_CS_CS_CP1258
	ElseIf c = "850"
		t = #AWPB_CS_CS_ISO_8859_1
	ElseIf c = "CP850"
		t = #AWPB_CS_CS_ISO_8859_1
	ElseIf c = "IBM850"
		t = #AWPB_CS_CS_ISO_8859_1
	ElseIf c = "CSPC850MULTILINGUAL"
		t = #AWPB_CS_CS_ISO_8859_1
	ElseIf c = "862"
		t = #AWPB_CS_CS_CP862
	ElseIf c = "CP862"
		t = #AWPB_CS_CS_CP862
	ElseIf c = "IBM862"
		t = #AWPB_CS_CS_CP862
	ElseIf c = "CSPC862LATINHEBREW"
		t = #AWPB_CS_CS_CP862
	ElseIf c = "866"
		t = #AWPB_CS_CS_CP866
	ElseIf c = "CP866"
		t = #AWPB_CS_CS_CP866
	ElseIf c = "IBM866"
		t = #AWPB_CS_CS_CP866
	ElseIf c = "CSIBM866"
		t = #AWPB_CS_CS_CP866
	ElseIf c = "MAC"
		t = #AWPB_CS_CS_MAC
	ElseIf c = "MACINTOSH"
		t = #AWPB_CS_CS_MAC
	ElseIf c = "MACROMAN"
		t = #AWPB_CS_CS_MAC
	ElseIf c = "CSMACINTOSH"
		t = #AWPB_CS_CS_MAC
	ElseIf c = "MACCENTRALEUROPE"
		t = #AWPB_CS_CS_MACCE
	ElseIf c = "MACICELAND"
		t = #AWPB_CS_CS_MACICE
	ElseIf c = "MACCROATIAN"
		t = #AWPB_CS_CS_MACCRO
	ElseIf c = "MACROMANIA"
		t = #AWPB_CS_CS_MACRO
	ElseIf c = "MACCYRILLIC"
		t = #AWPB_CS_CS_MACCYR
	ElseIf c = "MACUKRAINE"
		t = #AWPB_CS_CS_MACUK
	ElseIf c = "MACGREEK"
		t = #AWPB_CS_CS_MACGR
	ElseIf c = "MACTURKISH"
		t = #AWPB_CS_CS_MACTU
	ElseIf c = "MACHEBREW"
		t = #AWPB_CS_CS_MACHEB
	ElseIf c = "MACARABIC"
		t = #AWPB_CS_CS_MACAR
	ElseIf c = "MACTHAI"
		t = #AWPB_CS_CS_MACTH
	ElseIf c = "HP-ROMAN8"
		t = #AWPB_CS_CS_ROMAN8
	ElseIf c = "R8"
		t = #AWPB_CS_CS_ROMAN8
	ElseIf c = "ROMAN8"
		t = #AWPB_CS_CS_ROMAN8
	ElseIf c = "CSHPROMAN8"
		t = #AWPB_CS_CS_ROMAN8
	ElseIf c = "NEXTSTEP"
		t = #AWPB_CS_CS_NEXTSTEP
	ElseIf c = "ARMSCII-8"
		t = #AWPB_CS_CS_ARMASCII
	ElseIf c = "GEORGIAN-ACADEMY"
		t = #AWPB_CS_CS_GEORGIAN_AC
	ElseIf c = "GEORGIAN-PS"
		t = #AWPB_CS_CS_GEORGIAN_PS
	ElseIf c = "KOI8-T"
		t = #AWPB_CS_CS_KOI8_T
	ElseIf c = "MULELAO-1"
		t = #AWPB_CS_CS_MULELAO
	ElseIf c = "CP1133"
		t = #AWPB_CS_CS_CP1133
	ElseIf c = "IBM-CP1133"
		t = #AWPB_CS_CS_CP1133
	ElseIf c = "TIS-620"
		t = #AWPB_CS_CS_TIS620
	ElseIf c = "ISO-IR-166"
		t = #AWPB_CS_CS_TIS620
	ElseIf c = "TIS620"
		t = #AWPB_CS_CS_TIS620
	ElseIf c = "TIS620-0"
		t = #AWPB_CS_CS_TIS620
	ElseIf c = "TIS620.2529-1"
		t = #AWPB_CS_CS_TIS620
	ElseIf c = "TIS620.2533-0"
		t = #AWPB_CS_CS_TIS620
	ElseIf c = "TIS620.2533-1"
		t = #AWPB_CS_CS_TIS620
	ElseIf c = "CP874"
		t = #AWPB_CS_CS_CP874
	ElseIf c = "WINDOWS-874"
		t = #AWPB_CS_CS_CP874
	ElseIf c = "VISCII"
		t = #AWPB_CS_CS_VISCII
	ElseIf c = "VISCII1.1-1"
		t = #AWPB_CS_CS_VISCII
	ElseIf c = "CSVISCII"
		t = #AWPB_CS_CS_VISCII
	ElseIf c = "TCVN"
		t = #AWPB_CS_CS_TCVN
	ElseIf c = "TCVN-5712"
		t = #AWPB_CS_CS_TCVN
	ElseIf c = "TCVN5712-1"
		t = #AWPB_CS_CS_TCVN
	ElseIf c = "TCVN5712-1:1993"
		t = #AWPB_CS_CS_TCVN
	ElseIf c = "ISO-IR-14"
		t = #AWPB_CS_CS_ISO_IR_14
	ElseIf c = "ISO646-JP"
		t = #AWPB_CS_CS_ISO_IR_14
	ElseIf c = "JIS_C6220-1969-RO"
		t = #AWPB_CS_CS_ISO_IR_14
	ElseIf c = "JP"
		t = #AWPB_CS_CS_ISO_IR_14
	ElseIf c = "CSISO14JISC6220RO"
		t = #AWPB_CS_CS_ISO_IR_14
	ElseIf c = "JISX0201-1976"
		t = #AWPB_CS_CS_JIS_X0201
	ElseIf c = "JIS_X0201"
		t = #AWPB_CS_CS_JIS_X0201
	ElseIf c = "X0201"
		t = #AWPB_CS_CS_JIS_X0201
	ElseIf c = "CSHALFWIDTHKATAKANA"
		t = #AWPB_CS_CS_JIS_X0201
	ElseIf c = "ISO-IR-87"
		t = #AWPB_CS_CS_JIS_X0208
	ElseIf c = "JIS0208"
		t = #AWPB_CS_CS_JIS_X0208
	ElseIf c = "JIS_C6226-1983"
		t = #AWPB_CS_CS_JIS_X0208
	ElseIf c = "JIS_X0208"
		t = #AWPB_CS_CS_JIS_X0208
	ElseIf c = "JIS_X0208-1983"
		t = #AWPB_CS_CS_JIS_X0208
	ElseIf c = "JIS_X0208-1990"
		t = #AWPB_CS_CS_JIS_X0208
	ElseIf c = "X0208"
		t = #AWPB_CS_CS_JIS_X0208
	ElseIf c = "CSISO87JISX0208"
		t = #AWPB_CS_CS_JIS_X0208
	ElseIf c = "ISO-IR-159"
		t = #AWPB_CS_CS_JIS_X0212
	ElseIf c = "JIS_X0212"
		t = #AWPB_CS_CS_JIS_X0212
	ElseIf c = "JIS_X0212-1990"
		t = #AWPB_CS_CS_JIS_X0212
	ElseIf c = "JIS_X0212.1990-0"
		t = #AWPB_CS_CS_JIS_X0212
	ElseIf c = "X0212"
		t = #AWPB_CS_CS_JIS_X0212
	ElseIf c = "CSISO159JISX02121990"
		t = #AWPB_CS_CS_JIS_X0212
	ElseIf c = "CN"
		t = #AWPB_CS_CS_GB1988_80
	ElseIf c = "GB_1988-80"
		t = #AWPB_CS_CS_GB1988_80
	ElseIf c = "ISO-IR-57"
		t = #AWPB_CS_CS_GB1988_80
	ElseIf c = "ISO646-CN"
		t = #AWPB_CS_CS_GB1988_80
	ElseIf c = "CSISO57GB1988"
		t = #AWPB_CS_CS_GB1988_80
	ElseIf c = "CHINESE"
		t = #AWPB_CS_CS_GB2312_80
	ElseIf c = "GB_2312-80"
		t = #AWPB_CS_CS_GB2312_80
	ElseIf c = "ISO-IR-58"
		t = #AWPB_CS_CS_GB2312_80
	ElseIf c = "CSISO58GB231280"
		t = #AWPB_CS_CS_GB2312_80
	ElseIf c = "CN-GB-ISOIR165"
		t = #AWPB_CS_CS_ISO_IR_165
	ElseIf c = "ISO-IR-165"
		t = #AWPB_CS_CS_ISO_IR_165
	ElseIf c = "ISO-IR-149"
		t = #AWPB_CS_CS_ISO_IR_149
	ElseIf c = "KOREAN"
		t = #AWPB_CS_CS_ISO_IR_149
	ElseIf c = "KSC_5601"
		t = #AWPB_CS_CS_ISO_IR_149
	ElseIf c = "KS_C_5601-1987"
		t = #AWPB_CS_CS_ISO_IR_149
	ElseIf c = "KS_C_5601-1989"
		t = #AWPB_CS_CS_ISO_IR_149
	ElseIf c = "CSKSC56011987"
		t = #AWPB_CS_CS_ISO_IR_149
	ElseIf c = "EUC-JP"
		t = #AWPB_CS_CS_EUC_JP
	ElseIf c = "EUCJP"
		t = #AWPB_CS_CS_EUC_JP
	ElseIf c = "EXTENDED_UNIX_CODE_PACKED_FORMAT_FOR_JAPANESE"
		t = #AWPB_CS_CS_EUC_JP
	ElseIf c = "CSEUCPKDFMTJAPANESE"
		t = #AWPB_CS_CS_EUC_JP
	ElseIf c = "SHIFT-JIS"
		t = #AWPB_CS_CS_SHIFT_JIS
	ElseIf c = "MS_KANJI"
		t = #AWPB_CS_CS_SHIFT_JIS
	ElseIf c = "SHIFT_JIS"
		t = #AWPB_CS_CS_SHIFT_JIS
	ElseIf c = "SJIS"
		t = #AWPB_CS_CS_SHIFT_JIS
	ElseIf c = "CSSHIFTJIS"
		t = #AWPB_CS_CS_SHIFT_JIS
	ElseIf c = "CP932"
		t = #AWPB_CS_CS_CP932
	ElseIf c = "ISO-2022-JP"
		t = #AWPB_CS_CS_ISO_2022_JP
	ElseIf c = "CSISO2022JP"
		t = #AWPB_CS_CS_ISO_2022_JP
	ElseIf c = "ISO-2022-JP-1"
		t = #AWPB_CS_CS_ISO_2022_JP1
	ElseIf c = "ISO-2022-JP-2"
		t = #AWPB_CS_CS_ISO_2022_JP2
	ElseIf c = "CSISO2022JP2"
		t = #AWPB_CS_CS_ISO_2022_JP2
	ElseIf c = "CN-GB"
		t = #AWPB_CS_CS_GB2312
	ElseIf c = "EUC-CN"
		t = #AWPB_CS_CS_GB2312
	ElseIf c = "EUCCN"
		t = #AWPB_CS_CS_GB2312
	ElseIf c = "GB2312"
		t = #AWPB_CS_CS_GB2312
	ElseIf c = "CSGB2312"
		t = #AWPB_CS_CS_GB2312
	ElseIf c = "CP936"
		t = #AWPB_CS_CS_CP936
	ElseIf c = "GBK"
		t = #AWPB_CS_CS_CP936
	ElseIf c = "GB18030"
		t = #AWPB_CS_CS_GB18030
	ElseIf c = "ISO-2022-CN"
		t = #AWPB_CS_CS_ISO_2022_CN
	ElseIf c = "CSISO2022CN"
		t = #AWPB_CS_CS_ISO_2022_CN
	ElseIf c = "ISO-2022-CN-EXT"
		t = #AWPB_CS_CS_ISO_2022_CNE
	ElseIf c = "HZ"
		t = #AWPB_CS_CS_HZ
	ElseIf c = "HZ-GB-2312"
		t = #AWPB_CS_CS_HZ
	ElseIf c = "EUC-TW"
		t = #AWPB_CS_CS_EUC_TW
	ElseIf c = "EUCTW"
		t = #AWPB_CS_CS_EUC_TW
	ElseIf c = "CSEUCTW"
		t = #AWPB_CS_CS_EUC_TW
	ElseIf c = "BIG5"
		t = #AWPB_CS_CS_BIG5
	ElseIf c = "BIG-5"
		t = #AWPB_CS_CS_BIG5
	ElseIf c = "BIG-FIVE"
		t = #AWPB_CS_CS_BIG5
	ElseIf c = "BIGFIVE"
		t = #AWPB_CS_CS_BIG5
	ElseIf c = "CN-BIG5"
		t = #AWPB_CS_CS_BIG5
	ElseIf c = "CSBIG5"
		t = #AWPB_CS_CS_BIG5
	ElseIf c = "CP950"
		t = #AWPB_CS_CS_CP950
	ElseIf c = "BIG5-HKSCS"
		t = #AWPB_CS_CS_BIG5_HKSCS
	ElseIf c = "BIG5HKSCS"
		t = #AWPB_CS_CS_BIG5_HKSCS
	ElseIf c = "EUC-KR"
		t = #AWPB_CS_CS_EUC_KR
	ElseIf c = "EUCKR"
		t = #AWPB_CS_CS_EUC_KR
	ElseIf c = "CSEUCKR"
		t = #AWPB_CS_CS_EUC_KR
	ElseIf c = "CP949"
		t = #AWPB_CS_CS_CP949
	ElseIf c = "UHC"
		t = #AWPB_CS_CS_CP949
	ElseIf c = "CP1361"
		t = #AWPB_CS_CS_CP1361
	ElseIf c = "JOHAB"
		t = #AWPB_CS_CS_CP1361
	ElseIf c = "ISO-2022-KR"
		t = #AWPB_CS_CS_ISO_2022_KR
	ElseIf c = "CSISO2022KR"
		t = #AWPB_CS_CS_ISO_2022_KR
	ElseIf c = "437"
		t = #AWPB_CS_CS_ISO_8859_1
	ElseIf c = "CP437"
		t = #AWPB_CS_CS_ISO_8859_1
	ElseIf c = "IBM437"
		t = #AWPB_CS_CS_ISO_8859_1
	ElseIf c = "CSPC8CODEPAGE437"
		t = #AWPB_CS_CS_ISO_8859_1
	ElseIf c = "CP737"
		t = #AWPB_CS_CS_CP737
	ElseIf c = "CP775"
		t = #AWPB_CS_CS_CP775
	ElseIf c = "IBM775"
		t = #AWPB_CS_CS_CP775
	ElseIf c = "CSPC775BALTIC"
		t = #AWPB_CS_CS_CP775
	ElseIf c = "852"
		t = #AWPB_CS_CS_CP852
	ElseIf c = "CP852"
		t = #AWPB_CS_CS_CP852
	ElseIf c = "IBM852"
		t = #AWPB_CS_CS_CP852
	ElseIf c = "CSPCP852"
		t = #AWPB_CS_CS_CP852
	ElseIf c = "CP853"
		t = #AWPB_CS_CS_CP853
	ElseIf c = "855"
		t = #AWPB_CS_CS_CP855
	ElseIf c = "CP855"
		t = #AWPB_CS_CS_CP855
	ElseIf c = "IBM855"
		t = #AWPB_CS_CS_CP855
	ElseIf c = "CSIBM855"
		t = #AWPB_CS_CS_CP855
	ElseIf c = "857"
		t = #AWPB_CS_CS_CP857
	ElseIf c = "CP857"
		t = #AWPB_CS_CS_CP857
	ElseIf c = "IBM857"
		t = #AWPB_CS_CS_CP857
	ElseIf c = "CSIBM857"
		t = #AWPB_CS_CS_CP857
	ElseIf c = "CP858"
		t = #AWPB_CS_CS_CP858
	ElseIf c = "860"
		t = #AWPB_CS_CS_CP860
	ElseIf c = "CP860"
		t = #AWPB_CS_CS_CP860
	ElseIf c = "IBM860"
		t = #AWPB_CS_CS_CP860
	ElseIf c = "CSIBM860"
		t = #AWPB_CS_CS_CP860
	ElseIf c = "861"
		t = #AWPB_CS_CS_CP861
	ElseIf c = "CP-IS"
		t = #AWPB_CS_CS_CP861
	ElseIf c = "CP861"
		t = #AWPB_CS_CS_CP861
	ElseIf c = "IBM861"
		t = #AWPB_CS_CS_CP861
	ElseIf c = "CSIBM861"
		t = #AWPB_CS_CS_CP861
	ElseIf c = "863"
		t = #AWPB_CS_CS_CP863
	ElseIf c = "CP863"
		t = #AWPB_CS_CS_CP863
	ElseIf c = "IBM863"
		t = #AWPB_CS_CS_CP863
	ElseIf c = "CSIBM863"
		t = #AWPB_CS_CS_CP863
	ElseIf c = "CP864"
		t = #AWPB_CS_CS_CP864
	ElseIf c = "IBM864"
		t = #AWPB_CS_CS_CP864
	ElseIf c = "CSIBM864"
		t = #AWPB_CS_CS_CP864
	ElseIf c = "865"
		t = #AWPB_CS_CS_CP865
	ElseIf c = "CP865"
		t = #AWPB_CS_CS_CP865
	ElseIf c = "IBM865"
		t = #AWPB_CS_CS_CP865
	ElseIf c = "CSIBM865"
		t = #AWPB_CS_CS_CP865
	ElseIf c = "869"
		t = #AWPB_CS_CS_CP869
	ElseIf c = "CP-GR"
		t = #AWPB_CS_CS_CP869
	ElseIf c = "CP869"
		t = #AWPB_CS_CS_CP869
	ElseIf c = "IBM869"
		t = #AWPB_CS_CS_CP869
	ElseIf c = "CSIBM869"
		t = #AWPB_CS_CS_CP869
	ElseIf c = "CP1125"
		t = #AWPB_CS_CS_CP1125
  Else
    t = #AWPB_CS_CS_UNKNOWN
  EndIf
  
  ProcedureReturn t
EndProcedure
Procedure.s ____CS_GetCharsetName(charset.i)
  Protected c.s
  
  Select charset
		Case #AWPB_CS_CS_UTF_8
			c = "utf-8"
		Case #AWPB_CS_CS_UCS_2
			c = "ucs-2"
		Case #AWPB_CS_CS_UCS_4
			c = "ucs-4"
		Case #AWPB_CS_CS_UTF_16
			c = "utf-16"
		Case #AWPB_CS_CS_UTF_16LE
			c = "utf-16le"
		Case #AWPB_CS_CS_UTF_32
			c = "utf-32"
		Case #AWPB_CS_CS_UTF_7
			c = "utf-7"
		Case #AWPB_CS_CS_C99
			c = "c99"
		Case #AWPB_CS_CS_JAVA
			c = "java"
		Case #AWPB_CS_CS_ISO_8859_1
			c = "iso-8859-1"
		Case #AWPB_CS_CS_ISO_8859_2
			c = "iso-8859-2"
		Case #AWPB_CS_CS_ISO_8859_3
			c = "iso-8859-3"
		Case #AWPB_CS_CS_ISO_8859_4
			c = "iso-8859-4"
		Case #AWPB_CS_CS_ISO_8859_5
			c = "iso-8859-5"
		Case #AWPB_CS_CS_ISO_8859_6
			c = "iso-8859-6"
		Case #AWPB_CS_CS_ISO_8859_7
			c = "iso-8859-7"
		Case #AWPB_CS_CS_ISO_8859_8
			c = "iso-8859-8"
		Case #AWPB_CS_CS_ISO_8859_9
			c = "iso-8859-9"
		Case #AWPB_CS_CS_ISO_8859_10
			c = "iso-8859-10"
		Case #AWPB_CS_CS_ISO_8859_13
			c = "iso-8859-13"
		Case #AWPB_CS_CS_ISO_8859_14
			c = "iso-8859-14"
		Case #AWPB_CS_CS_ISO_8859_15
			c = "iso-8859-15"
		Case #AWPB_CS_CS_ISO_8859_16
			c = "iso-8859-16"
		Case #AWPB_CS_CS_KOI8_R
			c = "koi8-r"
		Case #AWPB_CS_CS_KOI8_U
			c = "koi8-u"
		Case #AWPB_CS_CS_KOI8_RU
			c = "koi8-ru"
		Case #AWPB_CS_CS_CP1250
			c = "cp1250"
		Case #AWPB_CS_CS_CP1251
			c = "cp1251"
		Case #AWPB_CS_CS_CP1252
			c = "cp1252"
		Case #AWPB_CS_CS_CP1253
			c = "cp1253"
		Case #AWPB_CS_CS_CP1254
			c = "cp1254"
		Case #AWPB_CS_CS_CP1255
			c = "cp1255"
		Case #AWPB_CS_CS_CP1256
			c = "cp1256"
		Case #AWPB_CS_CS_CP1257
			c = "cp1257"
		Case #AWPB_CS_CS_CP1258
			c = "cp1258"
		Case #AWPB_CS_CS_CP862
			c = "cp862"
		Case #AWPB_CS_CS_CP866
			c = "cp866"
		Case #AWPB_CS_CS_MAC
			c = "mac"
		Case #AWPB_CS_CS_MACCE
			c = "maccentraleurope"
		Case #AWPB_CS_CS_MACICE
			c = "maciceland"
		Case #AWPB_CS_CS_MACCRO
			c = "maccroatian"
		Case #AWPB_CS_CS_MACRO
			c = "macromania"
		Case #AWPB_CS_CS_MACCYR
			c = "maccyrillic"
		Case #AWPB_CS_CS_MACUK
			c = "macukraine"
		Case #AWPB_CS_CS_MACGR
			c = "macgreek"
		Case #AWPB_CS_CS_MACTU
			c = "macturkish"
		Case #AWPB_CS_CS_MACHEB
			c = "machebrew"
		Case #AWPB_CS_CS_MACAR
			c = "macarabic"
		Case #AWPB_CS_CS_MACTH
			c = "macthai"
		Case #AWPB_CS_CS_ROMAN8
			c = "roman8"
		Case #AWPB_CS_CS_NEXTSTEP
			c = "nextstep"
		Case #AWPB_CS_CS_ARMASCII
			c = "armscii-8"
		Case #AWPB_CS_CS_GEORGIAN_AC
			c = "georgian-academy"
		Case #AWPB_CS_CS_GEORGIAN_PS
			c = "georgian-ps"
		Case #AWPB_CS_CS_KOI8_T
			c = "koi8-t"
		Case #AWPB_CS_CS_MULELAO
			c = "mulelao-1"
		Case #AWPB_CS_CS_CP1133
			c = "cp1133"
		Case #AWPB_CS_CS_TIS620
			c = "tis-620"
		Case #AWPB_CS_CS_CP874
			c = "cp874"
		Case #AWPB_CS_CS_VISCII
			c = "viscii"
		Case #AWPB_CS_CS_TCVN
			c = "tcvn"
		Case #AWPB_CS_CS_ISO_IR_14
			c = "iso-ir-14"
		Case #AWPB_CS_CS_JIS_X0201
			c = "jis_x0201"
		Case #AWPB_CS_CS_JIS_X0208
			c = "jis_x0208"
		Case #AWPB_CS_CS_JIS_X0212
			c = "jis_x0212"
		Case #AWPB_CS_CS_GB1988_80
			c = "gb_1988-80"
		Case #AWPB_CS_CS_GB2312_80
			c = "gb_2312-80"
		Case #AWPB_CS_CS_ISO_IR_165
			c = "iso-ir-165"
		Case #AWPB_CS_CS_ISO_IR_149
			c = "iso-ir-149"
		Case #AWPB_CS_CS_EUC_JP
			c = "euc-jp"
		Case #AWPB_CS_CS_SHIFT_JIS
			c = "shift-jis"
		Case #AWPB_CS_CS_CP932
			c = "cp932"
		Case #AWPB_CS_CS_ISO_2022_JP
			c = "iso-2022-jp"
		Case #AWPB_CS_CS_ISO_2022_JP1
			c = "iso-2022-jp-1"
		Case #AWPB_CS_CS_ISO_2022_JP2
			c = "iso-2022-jp-2"
		Case #AWPB_CS_CS_GB2312
			c = "gb2312"
		Case #AWPB_CS_CS_CP936
			c = "cp936 gbk"
		Case #AWPB_CS_CS_GB18030
			c = "gb18030"
		Case #AWPB_CS_CS_ISO_2022_CN
			c = "iso-2022-cn"
		Case #AWPB_CS_CS_ISO_2022_CNE
			c = "iso-2022-cn-ext"
		Case #AWPB_CS_CS_HZ
			c = "hz"
		Case #AWPB_CS_CS_EUC_TW
			c = "euc-tw"
		Case #AWPB_CS_CS_BIG5
			c = "big5"
		Case #AWPB_CS_CS_CP950
			c = "cp950"
		Case #AWPB_CS_CS_BIG5_HKSCS
			c = "big5-hkscs"
		Case #AWPB_CS_CS_EUC_KR
			c = "euc-kr"
		Case #AWPB_CS_CS_CP949
			c = "cp949"
		Case #AWPB_CS_CS_CP1361
			c = "cp1361"
		Case #AWPB_CS_CS_ISO_2022_KR
			c = "iso-2022-kr"
		Case #AWPB_CS_CS_CP737
			c = "cp737"
		Case #AWPB_CS_CS_CP775
			c = "cp775"
		Case #AWPB_CS_CS_CP852
			c = "cp852"
		Case #AWPB_CS_CS_CP853
			c = "cp853"
		Case #AWPB_CS_CS_CP855
			c = "cp855"
		Case #AWPB_CS_CS_CP857
			c = "cp857"
		Case #AWPB_CS_CS_CP858
			c = "cp858"
		Case #AWPB_CS_CS_CP860
			c = "cp860"
		Case #AWPB_CS_CS_CP861
			c = "cp861"
		Case #AWPB_CS_CS_CP863
			c = "cp863"
		Case #AWPB_CS_CS_CP864
			c = "cp864"
		Case #AWPB_CS_CS_CP865
			c = "cp865"
		Case #AWPB_CS_CS_CP869
			c = "cp869"
		Case #AWPB_CS_CS_CP1125
			c = "cp1125"
    Default
      c = "unknown"
  EndSelect
  
  ProcedureReturn c
EndProcedure
Procedure.s ____CS_GetHTMLCharset(html.s)
  Protected p.i, e.i, res.s
  
  res = ""
  p   = FindString(html, "charset", p)
  If p
    p = FindString(html, "=", p)
    If p
      e = FindString(html, ">", p + 2)
      If e
        res = ____SUP_TrimWSQ(Mid(html, p + 1, e - p - 1))
        e   = FindString(res, Chr(34), 1)
        If e
          res = ____SUP_TrimWSQ(Left(res, e - 1))
        EndIf
      EndIf
    EndIf
  EndIf
  ProcedureReturn res
EndProcedure  
Procedure.i ____CS_GetSysCharsetCode()
	Protected c.i
	
	CompilerSelect #PB_Compiler_OS
		CompilerCase #PB_OS_Windows
			Protected acp.i
			
			acp = GetACP_()
			Select acp
		    Case 437, 850, 20127
		      c = #AWPB_CS_CS_ISO_8859_1
		    Case 737
		      c = #AWPB_CS_CS_CP737
		    Case 775
		      c = #AWPB_CS_CS_CP775
		    Case 852
		      c = #AWPB_CS_CS_CP852
		    Case 855
		      c = #AWPB_CS_CS_CP855
		    Case 857
		      c = #AWPB_CS_CS_CP857
		    Case 858
		      c = #AWPB_CS_CS_CP858
		    Case 860
		      c = #AWPB_CS_CS_CP860
		    Case 861
		      c = #AWPB_CS_CS_CP861
		    Case 862
		      c = #AWPB_CS_CS_CP862
		    Case 863
		      c = #AWPB_CS_CS_CP863
		    Case 864
		      c = #AWPB_CS_CS_CP864
		    Case 865
		      c = #AWPB_CS_CS_CP865
		    Case 866
		      c = #AWPB_CS_CS_CP866
		    Case 869
		      c = #AWPB_CS_CS_CP869
		    Case 874
		      c = #AWPB_CS_CS_ISO_8859_15
		    Case 895
		      c = #AWPB_CS_CS_CP895
		    Case 932
		      c = #AWPB_CS_CS_CP932
		    Case 936
		      c = #AWPB_CS_CS_CP936
		    Case 949
		      c = #AWPB_CS_CS_CP949
		    Case 950
		      c = #AWPB_CS_CS_CP950
		    Case 1200
		      c = #AWPB_CS_CS_UCS_2LE
		    Case 1201
		      c = #AWPB_CS_CS_UCS_2
		    Case 1250
		      c = #AWPB_CS_CS_CP1250
		    Case 1251
		      c = #AWPB_CS_CS_CP1251
		    Case 1253
		      c = #AWPB_CS_CS_CP1253
		    Case 1254
		      c = #AWPB_CS_CS_CP1254
		    Case 1255
		      c = #AWPB_CS_CS_CP1255
		    Case 1256
		      c = #AWPB_CS_CS_CP1256
		    Case 1257
		      c = #AWPB_CS_CS_CP1257
		    Case 1258
		      c = #AWPB_CS_CS_CP1258
		    Case 1361
		      c = #AWPB_CS_CS_CP1361
		    Case 10000
		      c = #AWPB_CS_CS_MAC
		    Case 10004
		      c = #AWPB_CS_CS_MACAR
		    Case 10005
		      c = #AWPB_CS_CS_MACHEB
		    Case 10006
		      c = #AWPB_CS_CS_MACGR
		    Case 10007
		      c = #AWPB_CS_CS_MACCYR
		    Case 10010
		      c = #AWPB_CS_CS_MACRO
		    Case 10017
		      c = #AWPB_CS_CS_MACUK
		    Case 10021
		      c = #AWPB_CS_CS_MACTH
		    Case 10029
		      c = #AWPB_CS_CS_MACCE
		    Case 10079
		      c = #AWPB_CS_CS_MACICE
		    Case 10081
		      c = #AWPB_CS_CS_MACTU
		    Case 10082
		      c = #AWPB_CS_CS_MACCRO
		    Case 12000
		      c = #AWPB_CS_CS_UCS_4LE
		    Case 12001
		      c = #AWPB_CS_CS_UCS_4
		    Case 20866
		      c = #AWPB_CS_CS_KOI8_R
		    Case 20932
		      c = #AWPB_CS_CS_JIS_X0208
		    Case 20936
		      c = #AWPB_CS_CS_GB2312
		    Case 21866
		      c = #AWPB_CS_CS_KOI8_U
		    Case 28591
		      c = #AWPB_CS_CS_ISO_8859_1
		    Case 28592
		      c = #AWPB_CS_CS_ISO_8859_2
		    Case 28593
		      c = #AWPB_CS_CS_ISO_8859_3
		    Case 28594
		      c = #AWPB_CS_CS_ISO_8859_4
		    Case 28595
		      c = #AWPB_CS_CS_ISO_8859_5
		    Case 28596, 708
		      c = #AWPB_CS_CS_ISO_8859_6
		    Case 28597
		      c = #AWPB_CS_CS_ISO_8859_7
		    Case 28598, 38598
		      c = #AWPB_CS_CS_ISO_8859_8
		    Case 28599
		      c = #AWPB_CS_CS_ISO_8859_9
		    Case 28605
		      c = #AWPB_CS_CS_ISO_8859_15
		    Case 50220
		      c = #AWPB_CS_CS_ISO_2022_JP
		    Case 50221
		      c = #AWPB_CS_CS_ISO_2022_JP1
		    Case 50222
		      c = #AWPB_CS_CS_ISO_2022_JP2
		    Case 50225
		      c = #AWPB_CS_CS_ISO_2022_KR
		    Case 50227
		      c = #AWPB_CS_CS_ISO_2022_CN
		    Case 50229
		      c = #AWPB_CS_CS_ISO_2022_CNE
		    Case 51932
		      c = #AWPB_CS_CS_EUC_JP
		    Case 51936
		      c = #AWPB_CS_CS_GB2312
		    Case 51949
		      c = #AWPB_CS_CS_EUC_KR
		    Case 52936
		      c = #AWPB_CS_CS_HZ
		    Case 54936
		      c = #AWPB_CS_CS_GB18030
		    Case 65000
		      c = #AWPB_CS_CS_UTF_7
		    Case 65001
		      c = #AWPB_CS_CS_UTF_8
		    Case 0
		      c = #AWPB_CS_CS_UCS_2LE
		  	Default
    			c = #AWPB_CS_CS_CP1252					
    	EndSelect
    CompilerCase #PB_OS_Linux
    	Protected res.s
    	
    	res = PeekS(nl_langinfo_(14))
    	res = UCase(res)
    	
    	If (FindString(res, "KAMENICKY") > 0) Or (FindString(res, "895") > 0)
    		c = #AWPB_CS_CS_CP895
    	ElseIf FindString(res, "MUTF-7") > 0
    		c = #AWPB_CS_CS_UTF_7mod
    	Else
    		c = ____CS_GetCharsetCode(res)
    		If c = #AWPB_CS_CS_UNKNOWN
    			c = #AWPB_CS_CS_ISO_8859_1
    		EndIf
    	EndIf
  CompilerEndSelect
	
	ProcedureReturn c
EndProcedure
Procedure.s ____CS_GetSysCharset()
	ProcedureReturn ____CS_GetCharsetName(____CS_GetSysCharsetCode())
	ProcedureReturn "iso-8859-1"
EndProcedure
;}
;{ public functions
Procedure.i AWPB_CS_GetCharsetCode(CharsetName.s)
  ProcedureReturn ____CS_GetCharsetCode(CharsetName) 
EndProcedure
Procedure.s AWPB_CS_GetCharsetName(CharsetCode.i)
  ProcedureReturn ____CS_GetCharsetName(CharsetCode)
EndProcedure
Procedure.s AWPB_CS_GetHTMLCharsetName(HTMLCode.s)
  ProcedureReturn ____CS_GetHTMLCharset(HTMLCode)
EndProcedure
Procedure.i AWPB_CS_GetHTMLCharsetCode(HTMLCode.s)
  ProcedureReturn ____CS_GetCharsetCode(____CS_GetHTMLCharset(HTMLCode))
EndProcedure
Procedure.s AWPB_CS_GetSysCharsetName()
  ProcedureReturn ____CS_GetSysCharset()
EndProcedure
Procedure.i AWPB_CS_GetSysCharsetCode()
  ProcedureReturn ____CS_GetCharsetCode(____CS_GetSysCharset())
EndProcedure
;}

