;    awgnupg.pbi
;    Version 0.1 [2010/08/11]
;    Copyright (C) 2011 Ronny Krueger
;
;    This file is part of AWPB-Tools.
;
;    AWPB-Tools is free software: you can redistribute it and/or modify
;    it under the terms of the GNU Lesser General Public License as published by
;    the Free Software Foundation, either version 3 of the License, or
;    (at your option) any later version.
;
;    AWPB-Tools is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU Lesser General Public License for more details.
;
;    You should have received a copy of the GNU Lesser General Public License
;    along with AWPB-Tools.  If not, see <http://www.gnu.org/licenses/>.

; notice: Key may be the HEX-Representation or an eMail-Address

;**
;* awgnupg.pbi_
;* Version 0.1_
;* _
;* GnuPG Interface fr PureBasic 4.50+_
;* Lizenz: LGPL V3_
;* _
;* Systemanforderungen:_
;* <table style="text-align: left;" border="0" cellpadding="2" cellspacing="0"><tbody><tr>
;* <td style="vertical-align: top;">Windows</td><td style="vertical-align: top;">[x]</td>
;* <td style="vertical-align: top;">Linux</td><td style="vertical-align: top;">[x]</td>
;* <td style="vertical-align: top;">Mac</td><td style="vertical-align: top;">[ ]</td></tr><tr>
;* <td style="vertical-align: top;">x86</td><td style="vertical-align: top;">[x]</td>
;* <td style="vertical-align: top;">x64</td><td style="vertical-align: top;">[x]</td>
;* <td style="vertical-align: top;">PPC</td><td style="vertical-align: top;">[ ]</td></tr><tr>
;* <td style="vertical-align: top;">ASCII</td><td style="vertical-align: top;">[x]</td>
;* <td style="vertical-align: top;">Unicode</td><td style="vertical-align: top;">[x]</td>
;* <td style="vertical-align: top;"></td><td style="vertical-align: top;"></td></tr></tbody></table>

;{ Private Constants
#____GPG_TRIM_LEFT  = 1
#____GPG_TRIM_RIGHT = 2
#____GPG_TRIM_BOTH  = #____GPG_TRIM_LEFT | #____GPG_TRIM_RIGHT
;}
;{ Private Functions
Procedure.i ____GPG_FindLastChar(txt.s, char.c)
  Protected *txt, len.i, pos.i
  
  len  = Len(txt)
  *txt = @txt + StringByteLength(txt) - SizeOf(char)
  For pos = len To 1 Step -1
    If PeekC(*txt) = char : Break : EndIf
    *txt - SizeOf(char)
  Next pos
  
  ProcedureReturn pos
EndProcedure
Procedure.s ____GPG_CreateMailAdrList(adr.s, separator.s = ":")   ;- ToDo 
  Protected k.i, ex.i, res.s, a.i
  Dim result$(0)
  
  res = ""
  ex  = CreateRegularExpression(#PB_Any, "(?:[a-z0-9!#$%&'*+/=?^_`{|}~-]+(?:\.[a-z0-9!#$%&'*+/=?^_`{|}~-]+)*|"+Chr(34)+"(?:[\x01-\x08\x0b\x0c\x0e-\x1f\x21\x23-\x5b\x5d-\x7f]|\\[\x01-\x09\x0b\x0c\x0e-\x7f])*"+Chr(34)+")@(?:(?:[a-z0-9](?:[a-z0-9-]*[a-z0-9])?\.)+[a-z0-9](?:[a-z0-9-]*[a-z0-9])?|\[(?:(?:25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.){3}(?:25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?|[a-z0-9-]*[a-z0-9]:(?:[\x01-\x08\x0b\x0c\x0e-\x1f\x21-\x5a\x53-\x7f]|\\[\x01-\x09\x0b\x0c\x0e-\x7f])+)\])")
  If ex
    k = ExtractRegularExpression(ex, adr, result$())
    If k
      res = result$(0)
      For a = 1 To k - 1
        res + separator + result$(a)
      Next a
    EndIf
    FreeRegularExpression(ex)
  EndIf
    
  ProcedureReturn res
EndProcedure
Procedure.s ____GPG_TrimWS(txt.s, trimmode.i = #____GPG_TRIM_BOTH)                        ; removes all not printable characters
  Protected *l, *r, test.c, res.s
  
  *l = @txt                                           ; erstes Zeichen
  *r = *l + StringByteLength(txt) - SizeOf(test)      ; letztes Zeichen
  
  If (trimmode & #____GPG_TRIM_LEFT) = #____GPG_TRIM_LEFT
    While (PeekC(*l) < 33) And (*l < *r) : *l + SizeOf(test) : Wend
  EndIf
  If (trimmode & #____GPG_TRIM_RIGHT) = #____GPG_TRIM_RIGHT
    While (PeekC(*r) < 33) And (*r > *l) : *r - SizeOf(test) : Wend
  EndIf
  
  If *r = *l
    If PeekC(*l) < 33
      res = ""
    Else
      res = Chr(PeekC(*l))      
    EndIf
  Else
    res = PeekS(*l, ((*r - *l) / SizeOf(test)) + 1)
  EndIf
  
  ProcedureReturn res   
EndProcedure
Procedure.s ____GPG_ExecuteGnuPGStr(GnuPGCmd.s, GnuPGArgs.s, GnuPGInput.s, *ExitCode = #Null)
  Protected GnuPGProc, GnuPGOut.s, ec.i, l.i, *dat, buf2.s

  ec        = -1
  GnuPGOut  = ""
  If GnuPGCmd
    GnuPGProc = RunProgram(GnuPGCmd, GnuPGArgs, "", #PB_Program_Open | #PB_Program_Read | #PB_Program_Write)
    If GnuPGProc
      l = Len(GnuPGInput)
       If l > 0
        CompilerIf #PB_Compiler_Unicode
          *dat = AllocateMemory(l + 2)
          If *dat
            PokeS(*dat, GnuPGInput, l, #PB_Ascii)
          EndIf
        CompilerElse
          *dat = @GnuPGInput
        CompilerEndIf
        If *dat
          WriteProgramData(GnuPGProc, *dat, l)
        EndIf
        CompilerIf #PB_Compiler_Unicode
          If *dat
            FreeMemory(*dat)
          EndIf
        CompilerEndIf
      EndIf
      WriteProgramData(GnuPGProc, #PB_Program_Eof, 0)
      While ProgramRunning(GnuPGProc)       
        CompilerIf #PB_Compiler_Unicode
          buf2     = ReadProgramString(GnuPGProc)   
          GnuPGOut + PeekS(@buf2, -1, #PB_Ascii) + Chr(13) + Chr(10)
        CompilerElse
          GnuPGOut + ReadProgramString(GnuPGProc) + Chr(13) + Chr(10)
        CompilerEndIf
      Wend
      ec = ProgramExitCode(GnuPGProc)
      KillProgram(GnuPGProc)
      CloseProgram(GnuPGProc)
      GnuPGOut = ____GPG_TrimWS(GnuPGOut, #____GPG_TRIM_RIGHT)
    EndIf
  EndIf
  
  If *ExitCode : PokeI(*ExitCode, ec) : EndIf
  
  ProcedureReturn GnuPGOut
EndProcedure
Procedure.b ____GPG_ExecuteGnuPGCode(GnuPGCmd.s, GnuPGArgs.s, GnuPGInput.s)
  Protected ec.i, res.s
  
  ec  = -1
  res = ____GPG_ExecuteGnuPGStr(GnuPGCmd, GnuPGArgs, GnuPGInput, @ec)
  If ec = 0
    ProcedureReturn #True
  EndIf
  
  ProcedureReturn #False
EndProcedure
Procedure.s ____GPG_GetAvailableMailAdresses(GnuPGCmd.s)
  Protected args.s, keywin, result.b, done.b, keys.s
  Protected keylist, infotext, btnaccept, btncancel, Event, WindowID, GadgetID, EventType
  Protected a, k.s, name.s, email.s
  
  keys = ____GPG_ExecuteGnuPGStr(GnuPGCmd, "--list-keys", "")
  If Len(keys)
    keys = ReplaceString(keys, Chr(13) + Chr(10), Chr(13))
    
    keywin = OpenWindow(#PB_Any, 0, 0, 450, 310, "..:: GnuPG keys ::..",  #PB_Window_TitleBar | #PB_Window_ScreenCentered )
    If IsWindow(keywin)
      keylist   = ListIconGadget(#PB_Any, 10, 30, 430, 230, "Name", 200, #PB_ListIcon_CheckBoxes | #PB_ListIcon_FullRowSelect | #PB_ListIcon_AlwaysShowSelection)
                  AddGadgetColumn(keylist, 1, "eMail", 200)
      infotext  = TextGadget(#PB_Any, 10, 10, 90, 20, "select receipients")
      btnaccept = ButtonGadget(#PB_Any, 340, 270, 100, 30, "Accept")
      btncancel = ButtonGadget(#PB_Any, 230, 270, 100, 30, "Cancel")
      
      done      = #False
      result    = #False
          
      For a = 1 To CountString(keys, Chr(13))
        k = Trim(StringField(keys, a, Chr(13)))
      
        If Left(k, 3) = "uid"
          name  = Trim(Mid(k, 4, FindString(k, "<", 4) - 4))
          email = Trim(____GPG_CreateMailAdrList(k))
          AddGadgetItem(keylist, -1, name + Chr(10) + email)
        EndIf
      Next a
            
      Repeat
        Event     = WaitWindowEvent()     
        WindowID  = EventWindow()     
        GadgetID  = EventGadget()     
        EventType = EventType()
        
        If Event = #PB_Event_Gadget
          If GadgetID = keylist
            
          ElseIf GadgetID = btnaccept
            result = #True
            done   = #True
          ElseIf GadgetID = btncancel
            result = #False
            done   = #True
          EndIf
        EndIf
      Until done

      If result
        k = ""
        For a = 0 To CountGadgetItems(keylist) - 1
          If (GetGadgetItemState(keylist, a) & #PB_ListIcon_Checked) = #PB_ListIcon_Checked
            k + GetGadgetItemText(keylist, a, 1) + " "
          EndIf
        Next a
      EndIf

      CloseWindow(keywin)       
              
      If result
        keys = ____GPG_CreateMailAdrList(k)         
      Else
        keys = ""
      EndIf

      ProcedureReturn keys        
    EndIf     
  EndIf
   
  ProcedureReturn ""
EndProcedure
Procedure.s ____GPG_GetAvailableSecretMailAdresses(GnuPGCmd.s)
  Protected args.s, keywin, result.b, done.b, keys.s
  Protected keylist, infotext, btnaccept, btncancel, Event, WindowID, GadgetID, EventType
  Protected a, k.s, name.s, email.s
  
  keys = ____GPG_ExecuteGnuPGStr(GnuPGCmd, "--list-secret-keys", "")
  If Len(keys)
    keys = ReplaceString(keys, Chr(13) + Chr(10), Chr(13))
    
    keywin = OpenWindow(#PB_Any, 0, 0, 450, 310, "..:: GnuPG secret keys ::..",  #PB_Window_TitleBar | #PB_Window_ScreenCentered )
    If IsWindow(keywin)
      keylist   = ListIconGadget(#PB_Any, 10, 30, 430, 230, "Name", 200, #PB_ListIcon_CheckBoxes | #PB_ListIcon_FullRowSelect | #PB_ListIcon_AlwaysShowSelection)
                  AddGadgetColumn(keylist, 1, "eMail", 200)
      infotext  = TextGadget(#PB_Any, 10, 10, 90, 20, "select receipients")
      btnaccept = ButtonGadget(#PB_Any, 340, 270, 100, 30, "Accept")
      btncancel = ButtonGadget(#PB_Any, 230, 270, 100, 30, "Cancel")
      
      done      = #False
      result    = #False

      For a = 1 To CountString(keys, Chr(13))
        k = Trim(StringField(keys, a, Chr(13)))
      
        If Left(k, 3) = "uid"
          name  = Trim(Mid(k, 4, FindString(k, "<", 4) - 4))
          email = Trim(____GPG_CreateMailAdrList(k))
          AddGadgetItem(keylist, -1, name + Chr(10) + email)
        EndIf
      Next a
      
      Repeat
        Event     = WaitWindowEvent()     
        WindowID  = EventWindow()     
        GadgetID  = EventGadget()     
        EventType = EventType()
        
        If Event = #PB_Event_Gadget
          If GadgetID = keylist
            
          ElseIf GadgetID = btnaccept
            result = #True
            done   = #True
          ElseIf GadgetID = btncancel
            result = #False
            done   = #True
          EndIf
        EndIf
      Until done

      If result
        k = ""
        For a = 0 To CountGadgetItems(keylist) - 1
          If (GetGadgetItemState(keylist, a) & #PB_ListIcon_Checked) = #PB_ListIcon_Checked
            k + GetGadgetItemText(keylist, a, 1) + " "
          EndIf
        Next a
      EndIf

      CloseWindow(keywin)       
              
      If result
        keys = ____GPG_CreateMailAdrList(k)         
      Else
        keys = ""
      EndIf

      ProcedureReturn keys        
    EndIf     
  EndIf
  
  ProcedureReturn ""
EndProcedure
Procedure.s ____GPG_Encrypt(GnuPGCmd.s, GnuPGIn.s, keyIDs.s)
  Protected args.s, c.i, a.i, RecOk.b, res.s
  
  res   = ""
  c     = CountString(keyIDs, ":")
  args  = ""
  RecOk = #False

  For a = 1 To c
    args + " -r " + StringField(keyIDs, a, ":")
  Next a
  If (c = 0) And (Len(keyIDs) > 0)
    args = " -r " + keyIDs
    RecOk = #True
  ElseIf c <> 0
    RecOk = #True
  EndIf
  args = Trim(args) + " --encrypt --armor --yes --no-tty"

  If RecOk
    res = ____GPG_ExecuteGnuPGStr(GnuPGCmd, args, GnuPGIn)
  EndIf
  
  ProcedureReturn res
EndProcedure
Procedure.s ____GPG_Decrypt(GnuPGCmd.s, GnuPGIn.s, pass.s)
  Protected res.s, args.s

  args = "--decrypt --armor --no-tty --yes --passphrase " + pass
  res  = ____GPG_ExecuteGnuPGStr(GnuPGCmd, args, GnuPGIn)

  ProcedureReturn res
EndProcedure
Procedure.s ____GPG_Sign(GnuPGCmd.s, GnuPGIn.s, keyID.s, pass.s)
  Protected res.s, args.s

  args = "--clearsign --no-tty --yes --local-user " + keyID + " --passphrase " + pass
  res  = ____GPG_ExecuteGnuPGStr(GnuPGCmd, args, GnuPGIn)

  ProcedureReturn res
EndProcedure
Procedure.b ____GPG_VerifySignature(GnuPGCmd.s, GnuPGIn.s)
  Protected res.i, args.s

  args = "--verify --no-tty"
  res  = ____GPG_ExecuteGnuPGCode(GnuPGCmd, args, GnuPGIn)

  ProcedureReturn res
EndProcedure
Procedure.s ____GPG_SignAndEncrypt(GnuPGCmd.s, GnuPGIn.s, userKeyID.s, keyIDs.s, pass.s)
  Protected res.s, args.s, c.i, a.i, RecOk.b

  res   = ""
  c     = CountString(keyIDs, ":")
  args  = ""
  RecOk = #False

  For a = 1 To c
    args + " -r " + StringField(keyIDs, a, ":")
  Next a
  If (c = 0) And (Len(keyIDs) > 0)
    args = " -r " + keyIDs
    RecOk = #True
  ElseIf c <> 0
    RecOk = #True
  EndIf
  args = Trim(args) + " -se --armor --no-tty --yes --local-user " + userKeyID + " --passphrase " + pass

  If RecOk
    res = ____GPG_ExecuteGnuPGStr(GnuPGCmd, args, GnuPGIn)
  EndIf

  ProcedureReturn res
EndProcedure
Procedure.b ____GPG_KeyExists(GnuPGCmd.s, keyID.s)
  Protected res.i, args.s

  args = "--list-keys " + keyID
  res  = ____GPG_ExecuteGnuPGCode(GnuPGCmd, args, "")

  ProcedureReturn res
EndProcedure
Procedure.s ____GPG_SelectGPGRequester()
  Protected GnuPGCmd.s, Pattern.s
  
  CompilerIf #PB_Compiler_OS = #PB_OS_Windows
    Pattern = "gpg.exe|gpg.exe|gnupg.exe|gnupg.exe|All executables|*.exe"
  CompilerElse
    Pattern = "gpg|gpg|gnupg|gnupg|All files|*"
  CompilerEndIf 
  GnuPGCmd.s = OpenFileRequester("Select GPG executable", "", Pattern, 0)
  
  ProcedureReturn GnuPGCmd
EndProcedure
Procedure.s ____GPG_GetVersion(GnuPGCmd.s)
  Protected ver.s, spos.i
  
  ver  = ____GPG_ExecuteGnuPGStr(GnuPGCmd, "--version", "")
  ver  = StringField(ver, 1, Chr(13))
  spos = ____GPG_FindLastChar(StringField(ver, 1, Chr(13)), ' ')
  If spos 
    ver = Mid(ver, spos + 1)
  EndIf
  ver = ____GPG_TrimWS(ver)
  
  ProcedureReturn ver 
EndProcedure
;}
;{ Public Functions
;** awpb_gnupg_getavailablemailadresses
;* Gibt eine Liste von eMail-Adressen zurck zu denen ein ffentlicher Key vorhanden ist._
;* Die Auswahl wird vorher in einem Requester angezeigt, und kann vom Benutzer gendert werden._
;* Bei Fehlern wird ein leerer String zurckgegeben.
;** .GnuPGCmd.s: Pfad zum GnuPG Executable
Procedure.s AWPB_GnuPG_GetAvailableMailAdresses(GnuPGCmd.s)
  ProcedureReturn ____GPG_GetAvailableMailAdresses(GnuPGCmd)
EndProcedure
;** awpb_gnupg_getavailablesecretmailadresses
;* Gibt eine Liste von eMail-Adressen zurck zu denen ein privater Key vorhanden ist._
;* Die Auswahl wird vorher in einem Requester angezeigt, und kann vom Benutzer gendert werden._
;* Bei Fehlern wird ein leerer String zurckgegeben.
;** .GnuPGCmd.s: Pfad zum GnuPG Executable
Procedure.s AWPB_GnuPG_GetAvailableSecretMailAdresses(GnuPGCmd.s)
  ProcedureReturn ____GPG_GetAvailableSecretMailAdresses(GnuPGCmd)
EndProcedure
;** awpb_gnupg_encrypt
;* Verschlsselt den bergebenen Text fr die bergebenen Empfnger.
;* Zurckgegeben wird der verschlsselte Text in ANSI-Form._
;* Bei Fehlern wird ein leerer String zurckgegeben.
;** .GnuPGCmd.s: Pfad zum GnuPG Executable
;** .ClearText.s: zu verschlsselnder Text
;** .KeyIDs.s: Liste von ffentlichen IDs/eMails_
;* Die einzelnen Eintrge mssen durch einen Doppelpunkt (:) getrennt werden.
Procedure.s AWPB_GnuPG_Encrypt(GnuPGCmd.s, ClearText.s, KeyIDs.s)
  ProcedureReturn ____GPG_Encrypt(GnuPGCmd, ClearText, KeyIDs)
EndProcedure
;** awpb_gnupg_decrypt
;* Entschlsselt den bergebenen Text mit dem bergebenen Passwort.
;* Zurckgegeben wird der entschlsselte Text._
;* Bei Fehlern wird ein leerer String zurckgegeben.
;** .GnuPGCmd.s: Pfad zum GnuPG Executable
;** .CryptedText.s: zu entschlsselnder Text_
;* Der Text muss in ASCII-Form vorliegen.
;** .Password.s: Passwort eines der Empfnger des Textes
Procedure.s AWPB_GnuPG_Decrypt(GnuPGCmd.s, CryptedText.s, Password.s)
  ProcedureReturn ____GPG_Decrypt(GnuPGCmd, CryptedText, Password)
EndProcedure
;** awpb_gnupg_sign
;* Signiert den bergebenen Text mit dem bergebenen ID/Passwort-Kombination. Die ID muss sich auf einen privaten Schlssel beziehen.
;* Zurckgegeben wird der signierte Text._
;* Bei Fehlern wird ein leerer String zurckgegeben.
;** .GnuPGCmd.s: Pfad zum GnuPG Executable
;** .ClearText.s: zu signierender Text_
;* Der Text muss in ASCII-Form vorliegen.
;** .OwnKeyID.s: ID/eMail des Signierenden
;** .Password.s: Passwort zur ID des Signierenden
Procedure.s AWPB_GnuPG_Sign(GnuPGCmd.s, ClearText.s, OwnKeyID.s, Password.s)
  ProcedureReturn ____GPG_Sign(GnuPGCmd, ClearText, OwnKeyID, Password)
EndProcedure
;** awpb_gnupg_signandencrypt
;* Signiert und verschlsselt den bergebenen Text mit dem bergebenen ID/Passwort-Kombination fr die bergebenen Empfnger. Die ID muss sich auf einen privaten Schlssel beziehen.
;* Zurckgegeben wird der signierte Text._
;* Bei Fehlern wird ein leerer String zurckgegeben.
;** .GnuPGCmd.s: Pfad zum GnuPG Executable
;** .ClearText.s: zu signierender/verschlsselnder Text_
;* Der Text muss in ASCII-Form vorliegen.
;** .OwnKeyID.s: ID/eMail des Signierenden
;** .KeyIDs.s: Liste von ffentlichen IDs/eMails_
;* Die einzelnen Eintrge mssen durch einen Doppelpunkt (:) getrennt werden.
;** .Password.s: Passwort zur ID des Signierenden
Procedure.s AWPB_GnuPG_SignAndEncrypt(GnuPGCmd.s, ClearText.s, OwnKeyID.s, KeyIDs.s, Password.s)
  ProcedureReturn ____GPG_SignAndEncrypt(GnuPGCmd, ClearText, OwnKeyID, KeyIDs, Password)
EndProcedure
;** awpb_gnupg_verifysignature
;* berprft die Signatur des bergebenen Textes.
;* Zurckgegeben wird #True oder #False.
;** .GnuPGCmd.s: Pfad zum GnuPG Executable
;** .SignedText.s: zu prfender Text_
;* Der Text muss in ASCII-Form vorliegen.
Procedure.b AWPB_GnuPG_VerifySignature(GnuPGCmd.s, SignedText.s)
  ProcedureReturn ____GPG_VerifySignature(GnuPGCmd, SignedText)
EndProcedure
;** awpb_gnupg_keyexists
;* berprft ob ein ffentlicher Schlssel fr die bergebene ID/eMail existiert.
;* Zurckgegeben wird #True oder #False.
;** .GnuPGCmd.s: Pfad zum GnuPG Executable
;** .KeyID.s: ID oder eMail-Adresse
Procedure.b AWPB_GnuPG_KeyExists(GnuPGCmd.s, KeyID.s)
  ProcedureReturn ____GPG_KeyExists(GnuPGCmd, KeyID)
EndProcedure
;** awpb_gnupg_selectgpgrequester
;* Zeigt einen Requester zur Auswahl des GnuPG-Executables.
;* Zurckgegeben wird der vollstndige Pfad zum gewhlten GnuPG-Executable. Dieser kann direkt als GnuPGCmd benutzet werden.
Procedure.s AWPB_GnuPG_SelectGPGRequester()
  ProcedureReturn ____GPG_SelectGPGRequester()
EndProcedure
;** awpb_gnupg_getversion
;* Ermittelt die Version des bergebenen GnuPG-Executables. Bei Fehlern wird ein leerer String zurckgegeben.
;** .GnuPGCmd.s: Pfad zum GnuPG Executable
Procedure.s AWPB_GnuPG_GetVersion(GnuPGCmd.s)
  ProcedureReturn ____GPG_GetVersion(GnuPGCmd)
EndProcedure
;}
 

